/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** balls.h
**
** Gestion des balles (et des touches pour les dplacer)
**
**
*/

#ifndef BALLS_H
# define BALLS_H

/* Defines */
# define BALL_WIDTH 20
# define BALL_HEIGHT 20
# define BALL_RADIUS 10

# define BALL_ACCEL 5

/* Joueur ou IA ? */
# define BALL_PLAYER 1
# define BALL_IA 2

/* Rglages des touches par defaut, ne sert strictement a rien a part pouvoir modifier facilement */
# define BALLK_UP 1
# define BALLK_DOWN 2
# define BALLK_LEFT 4
# define BALLK_RIGHT 8

# define BALL1K_UP SDLK_UP
# define BALL1K_DOWN SDLK_DOWN
# define BALL1K_LEFT SDLK_LEFT
# define BALL1K_RIGHT SDLK_RIGHT

# define BALL2K_UP SDLK_z
# define BALL2K_DOWN SDLK_s
# define BALL2K_LEFT SDLK_q
# define BALL2K_RIGHT SDLK_d

# define BALL3K_UP SDLK_o
# define BALL3K_DOWN SDLK_l
# define BALL3K_LEFT SDLK_k
# define BALL3K_RIGHT SDLK_m

# define BALL4K_UP SDLK_KP5
# define BALL4K_DOWN SDLK_KP2
# define BALL4K_LEFT SDLK_KP1
# define BALL4K_RIGHT SDLK_KP3

# define BALL5K_UP SDLK_t
# define BALL5K_DOWN SDLK_g
# define BALL5K_LEFT SDLK_f
# define BALL5K_RIGHT SDLK_h

# define BALL6K_UP SDLK_KP_DIVIDE
# define BALL6K_DOWN SDLK_KP8
# define BALL6K_LEFT SDLK_KP7
# define BALL6K_RIGHT SDLK_KP9


/*# define COLLBALLS(x1,y1,x2,y2) (sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)) < (BALL_RADIUS*2))*/
# define COLLBALLS(x1,y1,x2,y2) ((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) < (BALL_RADIUS*2)*(BALL_RADIUS*2))
# define DSTBONUS(x1,y1,x2,y2) sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))

# define CENTREX(x) (x+BALL_WIDTH/2)
# define CENTREY(y) (y+BALL_HEIGHT/2)

/* Autres defines */
# define BALL_LIFES 3



/* Headers locaux */
# include "main.h"

struct s_ball {
	unsigned int type;	/* BALL_IA ou BALL_PLAYER */
	double speed;		/* Vitesse */
	unsigned int accel;     /* Acceleration (inertie en fait) */
	unsigned int score;	/* Score */
	unsigned int lifes;	/* Vie */
	double x;		/* Position */
	double y;
	double dx;		/* Dplacement */
	double dy;
	unsigned int keysdown;	/* Touches appuyes */
	unsigned int invincibletotaltime;	/* Temps total, pour le graph */
	unsigned int invinciblelast;	/* La dernier fois il tait */
	unsigned int invincibletime;	/* Temps restant en mode *invincible* */
	unsigned int bonuscount[BONUS_NB];	/* Stoque les bonus mangs */
};

void InitBalls();
void FreeBalls();

void MoveBalls();
void IAMovesBalls(struct s_bonus *bonus, struct s_walls *walls);

void HandleBalls(struct s_bonus *bonus, struct s_walls *walls);
void EventBalls(SDL_Event * event);

struct s_ball *balls;

#endif
