/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** main.c
**
** Fichier principal
**
**
**
*/

# include "main.h"

/*
** Dclarations des variables globales utilises dans le jeu
*/
struct s_colors colors = {
	{255, 0, 0, 0},
	{0, 0, 255, 0},
	{0, 255, 0, 0},
	{255, 255, 255, 0},
	{0, 0, 0, 0},
	{166, 166, 166, 0}
};

/* Options par defaut */
struct s_options options = {
	OPT_PLAYER_NB,
	OPT_IA_NB,
	OPT_MODE,
	OPT_WALLSIZE,
	OPT_SPEED,
	OPT_VRESOL,
	OPT_VMODE,
	{
	 {BALL1K_UP, BALL1K_DOWN, BALL1K_LEFT, BALL1K_RIGHT},
	 {BALL2K_UP, BALL2K_DOWN, BALL2K_LEFT, BALL2K_RIGHT},
	 {BALL3K_UP, BALL3K_DOWN, BALL3K_LEFT, BALL3K_RIGHT},
	 {BALL4K_UP, BALL4K_DOWN, BALL4K_LEFT, BALL4K_RIGHT},
	 {BALL5K_UP, BALL5K_DOWN, BALL5K_LEFT, BALL5K_RIGHT},
	 {BALL6K_UP, BALL6K_DOWN, BALL6K_LEFT, BALL6K_RIGHT}
	 }
};

/* Modes de jeu */
struct s_modes modes[OPTMAX_MODE + 1] = {
	{"Normal", 0},
	{"Arcade", MODE_ARCADE},
	{"Trace", MODE_TRACE},
	{"Arcade+Trace", MODE_ARCADE | MODE_TRACE}
};

/* Video */
char *vmodes[] = { "Windowed", "Fullscreen" };
struct s_vresols vresols[OPTMAX_VRESOL + 1] =
    { {800, 600}, {1024, 768}, {1152, 864}, {1280, 960}, {1280, 1024} };


/* pointeur vers la fentre */
SDL_Surface *screen;

int main(int argc, char **argv)
{

	if (Init() > 0)
		return EXIT_FAILURE;

	/* Lance le menu */
	StartMenu();

	return EXIT_SUCCESS;
}

/*
** Initialisation
** Retourne 0 si tout se passe bien, un chiffre plus grand sinon
*/
int Init()
{
	/* Lorsqu'on quitte, on appelle la fonction "Free" */
	atexit(Free);

	/* 
	 ** On met le driver qui_va_bien, il semble de directx fonctionne mal, 
	 ** du moins sur les pc de la fac 
	 */
#ifdef WIN32
	putenv("SDL_VIDEODRIVER=windib");
#endif

	/* On Initialise SDL (video et audio) */
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO) == -1) {
		perror("Can't Init SDL.\n");
		return 1;
	}

	/* Initialisation de la fentre */
	SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, 24, SDL_DOUBLEBUF);

	if (screen == NULL) {
		perror("Can't set video mode.\n");
		return 1;
	}

	/* Initialisation de SDL_ttf */
	if (TTF_Init() == -1) {
		fprintf(stderr, "Can't init SDL_TTF: %s\n",
			TTF_GetError());
		return 1;
	}

	/*Rglages de l'audio */
	int audio_rate = 22050;
	Uint16 audio_format = AUDIO_S16SYS;
	int audio_channels = 2;
	int audio_buffers = 4096;

	/* Initialisation de SDL_Mixer */
	if (Mix_OpenAudio
	    (audio_rate, audio_format, audio_channels,
	     audio_buffers) != 0) {
		fprintf(stderr, "Can't init SDL_Mixer: %s\n",
			Mix_GetError());
		return 1;
	}
	Mix_VolumeMusic(20);

	/* Change le titre de la fentre et de l'icne */
	SDL_WM_SetCaption("Ikswall", "Ikswall");
	SDL_WM_SetIcon(LoadSDLImage(DATA_PATH GAME_IMG_ICON, true), NULL);

	/* Rglages des rptitions du clavier */
	SDL_EnableKeyRepeat(100, 100);

	return 0;
}

/*
** Fonction permettant de fermer proprement le programme en librant tout ce qu'il faut.
*/
void Free()
{
	Mix_CloseAudio();
	TTF_Quit();
	SDL_Quit();
}
