/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** main.h
**
** Fichier principal
**
**
**
*/

#ifndef MAIN_H
# define MAIN_H

#ifndef WIN32
#if defined(_WIN32) || defined(__WIN32__)
# define WIN32
#endif
#endif


/* Include */
# include "SDL.h"

/* Librairies Standards */
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>

#ifdef WIN32
#include <windows.h>
#endif

/* Headers locaux */
# include "utils.h"
# include "game.h"
# include "balls.h"
# include "walls.h"
# include "bonus.h"
# include "menu.h"
# include "sound.h"
# include "messages.h"

/* Defines */
# define VERSION "0.8"

/* true et false */
# define false 0
# define true 1

/* Rsolution Horizontale */
# define SCREEN_WIDTH vresols[options.vresol].w
/* Rsolution Verticale */
# define SCREEN_HEIGHT vresols[options.vresol].h

/* Divers */
#if defined(LOCAL_PATH) || defined(WIN32)
# define DATA_PATH ""
#else
# define DATA_PATH "/usr/share/games/ikswall/"
#endif

# define GAME_FONT "fonts/bitstream.ttf"
# define GAME_IMG_ICON "sprites/ikswall.png"

/* Limitation FPS */
# define FPS 30

/* Options par defaut */
# define OPT_PLAYER_NB 1
# define OPT_IA_NB 0
# define OPT_MODE 0
# define OPT_WALLSIZE 1
# define OPT_SPEED 4
# define OPT_VRESOL 0
# define OPT_VMODE 0

# define OPTMIN_PLAYER_NB 1
# define OPTMIN_IA_NB 0
# define OPTMIN_MODE 0
# define OPTMIN_WALLSIZE 1
# define OPTMIN_SPEED 4
# define OPTMIN_VRESOL 0
# define OPTMIN_VMODE 0

# define OPTMAX_PLAYER_NB 6
# define OPTMAX_IA_NB 6
# define OPTMAX_MODE 3
# define OPTMAX_WALLSIZE 10
# define OPTMAX_SPEED 10
# define OPTMAX_VRESOL 4
# define OPTMAX_VMODE 1

# define OPTK_UP 0
# define OPTK_DOWN 1
# define OPTK_LEFT 2
# define OPTK_RIGHT 3

# define OPTK_NB 4

/* Flags pour les modes */
# define MODE_ARCADE 1
# define MODE_TRACE 2

int Init();
void Free();

struct s_colors {
	SDL_Color sdl_red;
	SDL_Color sdl_blue;
	SDL_Color sdl_green;
	SDL_Color sdl_white;
	SDL_Color sdl_black;
	SDL_Color sdl_grey;
};


struct s_options {
	unsigned int playernb;	/* nombre de joueurs */
	unsigned int ianb;
	unsigned int mode;	/* mode de jeu */
	unsigned int wallsize;	/* taille des murs */
	double speed;		/* vitesse de la balle et des murs */
	unsigned int vresol;	/* Resolution */
	unsigned int vmode;	/* Mode video 1 = FULLSCREEN | 2 = WINDOWED */
	unsigned int keys[OPTMAX_PLAYER_NB][OPTK_NB];	/* touches */
};

struct s_modes {
	char *name;		/* Nom */
	unsigned int flags;	/* Config */
};

struct s_vresols {
	unsigned int w;		/* Largeur */
	unsigned int h;		/* Hauteur */
};

const struct s_modes modes[OPTMAX_MODE + 1];
const struct s_colors colors;
struct s_options options;

const char *vmodes[OPTMAX_VMODE + 1];
const struct s_vresols vresols[OPTMAX_VRESOL + 1];

SDL_Surface *screen;
#endif
