/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** menu.h
**
** Gestion du menu
**
**
*/

#ifndef MENU_H
# define MENU_H

/* Include */
# include "SDL.h"

/* Defines */

/* Menu */
# define MENU_IMG_BACKGROUND "sprites/fond%dx%d.png"
# define MENU_IMG_ELEM "sprites/elements.png"
# define MENU_FONT_SIZE 10
# define MENU_FONT_SIZE_BIG 15

/* Divers */
# define MENU_ITM_TXT 0
# define MENU_ITM_OPT 1
# define MENU_ITM_FCT 2
# define MENU_ITM_LNK 3

/* Catgorie */
struct s_menu_item {
	char * text; /* Texte affich */

	uint type; /* Type: option, lance une fonction, va vers son "child" */
	
	/* Si MENU_ITM_FCT */
	void * fct; /* Pointeur vers la fonction a appeller */

	/* Si MENU_ITM_OPT */
	struct s_opt opt;

	/* Si MENU_ITM_LNK */ 
	struct s_menu_cat *lnk; /* Lien */

	SDL_Rect pos; /* Position */
	uint active; /* Etat : Actif // Inactif */
};

/* Ensemble de Catgories */
struct s_menu_cat {
	char *name; /* Nom */
	uint itemsnb; /* Nombre d'items */
	uint itemsmax; /* Max */
	struct s_menu_item *items; /* Ce qu'il y'a dedans */
	struct s_menu_cat *parent; /* Parent */
};

/* Pour le menu */
struct s_menu {
	TTF_Font *font;		/* contient la police */
	TTF_Font *fontBig;	/* contient la police (grosse) */
	SDL_Surface *bg;	/* contient l'image de fond */
	SDL_Surface *surf;	/* contient les images utiles (boutons, etc ..) */
	struct s_menu_cat *cats; /* Catgories */
};

/* Headers locaux */
# include "main.h"

void StartMenu();

void InitMenu(struct s_menu *menu);
void FreeMenu(struct s_menu *menu);

void HandleMenu(struct s_menu *menu);
void EventMenu(SDL_Event * event, struct s_menu *menu,
	       uint *isdone);

void InitCat(struct s_menu_cat **cat, char * name, uint itemsnb, struct s_menu_cat *parent);
void DrawCat(struct s_menu_cat *cat, TTF_Font *font, SDL_Color catcolor, SDL_Color actcolor, SDL_Color inactcolor);
void FreeCat(struct s_menu_cat *cat);

void AddItemTxt(struct s_menu_cat *cat, char * text);
void AddItemOpt(struct s_menu_cat *cat, char * text, struct opt opt);
void AddItemFct(struct s_menu_cat *cat, char * text, void *fct);
void AddItemLnk(struct s_menu_cat *cat, char * text, struct s_menu_cat *lnk);
void FreeItem(struct s_menu_item *item);
void DrawItem(struct s_menu_item *item, TTF_Font *font, SDL_Color *color);

#endif
