/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** walls.h
**
** Gestion des Murs
**
**
**
*/

#ifndef WALLS_H
# define WALLS_H

/* Include */
# include "SDL.h"

/* Defines */
# define WALLS_BUFFER 100

# define WALLS_WIDTH 5
/* Permet de passer sur les bords mais c'est pas drle
# define WALLS_BORDER_DECAL 25 */
# define WALLS_BORDER_DECAL 1

# define WALLS_VERT 0
# define WALLS_HORI 1

# define WALLS_SIZE_COEF 25

# define WALLS_ACCEL 10

# define WALLS_INVIC_TIME 2000

/* Structure contenant les murs individuellements */
struct s_wall {
	double x;		/* Position */
	double y;
	double dy;		/* Dplacement */
	double dx;
	unsigned int type;	/* Type */
};


/* Headers locaux */
# include "main.h"


void InitWalls(struct s_walls *walls);
void FreeWalls(struct s_walls *walls);

void MoveWalls(struct s_walls *walls, struct s_bonus *bonus);
void HandleWalls(struct s_walls *walls, struct s_bonus *bonus);

void AddWall(struct s_walls *walls);

#endif
