/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** bonus.h
**
** Gestion des bonus
**
**
**
*/

#ifndef BONUS_H
# define BONUS_H

/* Include */
# include "SDL.h"

/* Defines */
# define BONUS_WIDTH 15
# define BONUS_HEIGHT 15
# define BONUS_RADIUS 8

# define DSTBONUS(x1,y1,x2,y2) sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))

# define SCORE(pts) (7* (int) ceil((pts*log(options.speed.value+1)*log(options.wallsize.value+1))/(SCREEN_HEIGHT+SCREEN_HEIGHT)*4000))

/* Flags */
# define BONUS_IS_UNIQUE 1
# define BONUS_CAN_MAKE_BONUS 2
# define BONUS_MAKE_WALL 4
# define BONUS_GIVE_LIFE 8
# define BONUS_INVIC_10 16
# define BONUS_INVIC_20 32
# define BONUS_SPEED_UP_1 64
# define BONUS_SPEED_UP_2 128
# define BONUS_TAKE_LIFE 256
# define BONUS_CHANGE_ACCEL 512

struct s_1bonus {
	unsigned int type;	/* Type */
	unsigned int x;		/* Position */
	unsigned int y;
	struct s_1bonus *next;	/* Prcedent */
	struct s_1bonus *prev;	/* Suivant */
};

struct s_bonusconf {
	char *name;		/* Nom */
	unsigned int pts;	/* Points donnes */
	unsigned proba;		/* % de chance d'apparaitre */
	unsigned int flags;	/* Flags (actions associes en particulier) */
};

/* Headers locaux */
# include "main.h"


void InitBonus(struct s_bonus *bonus);
void FreeBonus(struct s_bonus *bonus);

void HandleBonus(struct s_bonus *bonus, struct s_walls *walls);

void AddRandBonus(struct s_bonus *bonus);

void AddBonus(struct s_bonus *bonus, unsigned int type, unsigned int x,
	      unsigned int y);
void DelBonus(struct s_bonus *bonus, struct s_1bonus *thebonus);

struct s_bonusconf bonusconf[BONUS_NB];

#endif
