/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** game.h
**
** Gestion de tout ce qui concerne le jeu.
**
**
*/

#ifndef GAME_H
# define GAME_H

/* Include */
# include "SDL.h"

/* Defines */
# define GAME_IMG_BGTILE "sprites/bgtile.png"
# define GAME_IMG_BALL "sprites/ball%d.png"
# define GAME_IMG_WALLS "sprites/walls.png"
# define GAME_IMG_BONUS "sprites/bonus.png"

# define GAME_BG_TILE_WIDTH 256
# define GAME_BG_TILE_HEIGHT 256

# define GAME_FONT_SIZE 8
# define GAME_FONT_SIZE_BIG 8

# define GAME_SOUND_GAMEOVER "sound/gameover.wav"
# define GAME_SOUND_BONUS "sound/bonus.wav"

# define BONUS_NB 10

struct s_game_ui {
	SDL_Surface *background;	/* Fond */
	SDL_Surface *bglefttop, *bgrighttop, *bgtile, *bgrightbottom, *bgleftbottom;	/*fond */
	TTF_Font *font;		/* contient la police */
	TTF_Font *fontBig;	/* contient la police (grosse) */
	SDL_Surface **balls;	/* Balles */
	SDL_Surface *walls;	/* Murs */
	SDL_Surface *bonus;	/* Bonus */
	Mix_Chunk *wavgameover;	/* Son de fin */
	Mix_Chunk *wavbonus;	/* Son quand on prend un bonus */
	struct s_messages *messages;	/* Les messages */
};

/* Structures dclares ii parce que sinon a compile pas bien */
/* Bonus */
struct s_bonus {
	unsigned int bonuscount[BONUS_NB];	/* Nombre de bonus sur le jeu */
	struct s_1bonus *first;	/* Premier de la chane */
	struct s_1bonus *last;	/* Dernier de la chane */
};

/* Murs */
struct s_walls {
	unsigned int wallsnb;	/* Nombre de murs */
	struct s_wall *walls;	/* Tableau contenant les murs */
};

/* Headers locaux */
# include "main.h"


void StartGame();

void InitGame();
void FreeGame();

void HandleGameBg();
void HandleGameFg();

void EventGame(SDL_Event * event, unsigned int *gameover);

void PauseGame(unsigned int *gameover);

void IsGameOver(unsigned int *gameover);
void ShowScore(struct s_walls *walls);

struct s_game_ui gameui;
#endif
