/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** main.h
**
** Fichier principal
**
**
**
*/

#ifndef MAIN_H
# define MAIN_H

#ifndef WIN32
#if defined(_WIN32) || defined(__WIN32__)
#define WIN32
#endif
#endif


/* Include */
# include "SDL.h"

/* Librairies Standards */
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>

#ifdef WIN32
#include <windows.h>
#else
#include <pwd.h>
#include <unistd.h>
#include <sys/types.h>
#endif

/* Headers locaux */
# include "utils.h"
# include "game.h"
# include "balls.h"
# include "walls.h"
# include "bonus.h"
# include "menu.h"
# include "sound.h"
# include "messages.h"

/* Defines */
# define VERSION "0.9-gp2x"

/* true et false */
# define false 0
# define true 1

/* Rsolution Horizontale */
# define SCREEN_WIDTH vresols[options.vresol.value].w
/* Rsolution Verticale */
# define SCREEN_HEIGHT vresols[options.vresol.value].h

/* Divers */
#if defined(LOCAL_PATH) || defined(WIN32)
# define DATA_PATH ""
#else
# define DATA_PATH "/usr/share/games/ikswall/"
#endif

# define GAME_FONT "fonts/bitstream.ttf"
# define GAME_IMG_ICON "sprites/ikswall.png"

/* Limitation FPS */
# define FPS 25

/* Options par defaut */
# define PLAYER_NAME_SIZE 64

# define OPTK_UP 0
# define OPTK_DOWN 1
# define OPTK_LEFT 2
# define OPTK_RIGHT 3

# define OPTK_NB 4

# define OPTMAX_PLAYERNB 6
# define OPTMAX_MODE 3
# define OPTMAX_VMODE 1
# define OPTMAX_VRESOL 5

/* Flags pour les modes */
# define MODE_ARCADE 1
# define MODE_TRACE 2

int Init();
void Free();

struct s_colors {
	SDL_Color sdl_red;
	SDL_Color sdl_blue;
	SDL_Color sdl_green;
	SDL_Color sdl_white;
	SDL_Color sdl_black;
	SDL_Color sdl_grey;
};

struct s_options {
	struct s_opt playernb;	/* nombre de joueurs */
	struct s_opt ianb;
	struct s_opt mode;	/* mode de OPTMAX_VRESOLjeu */
	struct s_opt wallsize;	/* taille des murs */
	struct s_opt speed;	/* vitesse de la balle et des murs */
	struct s_opt vresol;	/* Resolution */
	struct s_opt vmode;	/* Mode video 1 = FULLSCREEN | 0 = WINDOWED */
	/* Dernier Bon paramtres */
	int goodvresol;
	int goodvmode;
	uint keys[OPTMAX_PLAYERNB][OPTK_NB];	/* touches */
	char pnames[OPTMAX_PLAYERNB][PLAYER_NAME_SIZE]; /* nom des joueurs */
};

struct s_modes {
	char *name;		/* Nom */
	unsigned int flags;	/* Config */
};

struct s_vresols {
	unsigned int w;		/* Largeur */
	unsigned int h;		/* Hauteur */
};

const struct s_modes modes[OPTMAX_MODE + 1];
const struct s_colors colors;
struct s_options options;

const char *vmodes[OPTMAX_VMODE + 1];
const struct s_vresols vresols[OPTMAX_VRESOL + 1];

SDL_Surface *screen;
#endif
