/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier 
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite, 
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme 
**
** menu.c
**
** Gestion de l'interface
**
**
*/

# include "menu.h"

/* Ugly  */


/*
** Fonction qui lance le menu->
*/

void StartMenu()
{
	SDL_Event event;
	struct s_menu menu;
	unsigned int isdone = 0;

	InitMenu(&menu);


	while (!isdone) {
		HandleMenu(&menu);	/* gestion de l'affichage du menu */
		SDL_Flip(screen);
		limitFps();	/* Limite le nombre de fps pour conomiser un peu de cpu */
		/* Attente d'un evenement pour faire quoique ce soit */
                while (SDL_PollEvent(&event)) {
                        EventMenu(&event, &menu, &isdone);      /* gestion des evenements autres que quitter */
                }

	}

	FreeMenu(&menu);
}

/*
** Fonction permetant d'initialiser les variables du menu
*/
void InitMenu(struct s_menu *menu)
{
	char tmp[256];

	/*Chargement de l'image de fond */
	sprintf(tmp, DATA_PATH MENU_IMG_BACKGROUND, SCREEN_WIDTH,
		SCREEN_HEIGHT);
	menu->bg = LoadSDLImage(tmp, false);

	/* Chargement des elements graphiques */
	menu->surf = LoadSDLImage(DATA_PATH MENU_IMG_ELEM, true);

	/* chargement de la police utilise dans le jeu */
	menu->font = LoadSDLFont(DATA_PATH GAME_FONT, MENU_FONT_SIZE);

	/* chargement de la police utilise dans le jeu */
	menu->fontBig =
	    LoadSDLFont(DATA_PATH GAME_FONT, MENU_FONT_SIZE_BIG);


	/* Catgories, options, etc .... */
	InitCat(&menu->cats, "Ikswall", 4, 0, NULL);
	AddItemFct(menu->cats, "Play", StartGame);
	AddItemLnk(menu->cats, "Options", NULL);
	AddItemLnk(menu->cats, "Players", NULL);
	AddItemFct(menu->cats, "Quit", QuitMenu);

	InitCat(&menu->cats->items[1].lnk, menu->cats->items[1].text, 10,
		MENU_CAT_SHOW_BACK, menu->cats);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.playernb);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.ianb);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.speed);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.wallsize);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.mode);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.vresol);
	AddItemOpt(menu->cats->items[1].lnk, NULL, &options.vmode);
	//AddItemFct(menu->cats->items[1].lnk, "Save Options", SaveOptions);
	AddItemBck(menu->cats->items[1].lnk, "Back");

        InitCat(&menu->cats->items[2].lnk, menu->cats->items[2].text, 
		options.playernb.max, MENU_CAT_SHOW_BACK, menu->cats);
	for(uint i=0; i < options.playernb.max; i++) {
		AddItemInp(menu->cats->items[2].lnk, options.pnames[i], PLAYER_NAME_SIZE);
	}

	menu->curcat = menu->cats;
}

/*
** Fonction permetant de liberer l'espace mmoire allou au menu
*/
void FreeMenu(struct s_menu *menu)
{
	SDL_FreeSurface(menu->surf);	/* Elements graphiques */
	menu->surf = NULL;
	SDL_FreeSurface(menu->bg);	/* Fond */
	menu->bg = NULL;
	TTF_CloseFont(menu->font);	/* Police normale */
	menu->font = NULL;
	TTF_CloseFont(menu->fontBig);	/* Grande Police */
	menu->fontBig = NULL;
	FreeCat(&menu->cats);
}

/*
** Libre une catgorie (et la parcoure pour librer le reste)
*/
void FreeCat(struct s_menu_cat **cat)
{
	free((*cat)->name);
	for (uint i = 0; i < (*cat)->itemsnb; ++i) {
		if ((*cat)->items[i].type == MENU_ITM_LNK) {
			FreeCat(&((*cat)->items[i].lnk));
		}
		if((*cat)->items[i].type != MENU_ITM_INP) {
			free((*cat)->items[i].text);
		}
	}
}

/*
** Fonction qui gre l'affichage du menu
*/
void HandleMenu(struct s_menu *menu)
{
	SDL_Rect src, dst;
	char tmp[256];
	unsigned int i;

	/* Image de fond */
	src.x = src.y = 0;
	src.w = menu->bg->w;
	src.h = menu->bg->h;
	dst.x = dst.y = 0;
	dst.w = src.w;
	dst.h = src.h;
	SDL_BlitSurface(menu->bg, &src, SDL_GetVideoSurface(), &dst);

	dst.x = 50;
	dst.y = 50;
	DrawCat(menu->curcat, menu->fontBig, colors.sdl_grey,
		colors.sdl_blue, colors.sdl_grey, &dst);

	/*
	 ** Divers
	 */
	/* version (inutile) */
	sprintf(tmp, "v %s", VERSION);
	dst.x = screen->w - 30;
	dst.y = screen->h - 11;
	PrintText(SDL_GetVideoSurface(), tmp, &dst, menu->font,
		  colors.sdl_grey);


	/* FPS (inutile) */
	sprintf(tmp, "FPS %d", nb_fps);
	dst.x = screen->w - 60;
	dst.y = 1;
	PrintText(SDL_GetVideoSurface(), tmp, &dst, menu->font,
		  colors.sdl_grey);

	/* Touches */
/*
	for (i = 0; i < options.playernb.value; i++) {
		dst.x = screen->w - 50;
		dst.y = 75 * (i + 1);

		if (options.playernb.value - (i + 1) < options.ianb.value)
			sprintf(tmp, "%s (AI)", options.pnames[i]);
		else
			sprintf(tmp, "%s", options.pnames[i]);

		PrintText(SDL_GetVideoSurface(), tmp, &dst, menu->font,
			  colors.sdl_grey);

		dst.x += 100;
		DrawKeyMod(menu, options.keys[i][OPTK_UP], &dst);
		dst.y += BUTTON3_HEIGHT;
		DrawKeyMod(menu, options.keys[i][OPTK_DOWN], &dst);
		dst.x -= BUTTON3_WIDTH;
		DrawKeyMod(menu, options.keys[i][OPTK_LEFT], &dst);
		dst.x += BUTTON3_WIDTH * 2;
		DrawKeyMod(menu, options.keys[i][OPTK_RIGHT], &dst);
	}
*/
}


/*
** Dessine de quoi rgler une touche
*/
void DrawKeyMod(struct s_menu *menu, unsigned int keysym, SDL_Rect * orig)
{
	SDL_Rect src, dst;

	dst = *orig;

	src.x = BUTTON1_WIDTH + BUTTON2_WIDTH;
	src.y = 0;
	src.w = dst.w = BUTTON3_WIDTH;
	src.h = dst.h = BUTTON3_HEIGHT;

	dst.y -= (BUTTON3_HEIGHT - MENU_FONT_SIZE) / 2;
	/* Dessin du "bouton" */
	SDL_BlitSurface(menu->surf, &src, SDL_GetVideoSurface(), &dst);

	dst.x += 7;
	dst.y += 7;
	/* Texte */
	PrintText(SDL_GetVideoSurface(), SDL_GetKeyName(keysym), &dst,
		  menu->font, colors.sdl_grey);
}


/*
** Gre les evenements sur le menu (click et clavier)
*/
void
EventMenu(SDL_Event * event, struct s_menu *menu, unsigned int *isdone)
{
	if (!event)
		return;

	struct s_menu_item *item =
	    &menu->curcat->items[menu->curcat->itemactive];


	switch (event->type) {
	case SDL_KEYDOWN:	/* Touche appuye */
		if (event->key.state == SDL_PRESSED) {
			if (event->key.keysym.sym == IK_ESC) {
				if (menu->curcat->parent)
					menu->curcat =
					    menu->curcat->parent;
				else
					*isdone = 1;
			} else if (event->key.keysym.sym == IK_UP) {
				/* HAUT et  BAS permettent de selectionner les boutons */
				if (menu->curcat->itemactive == 0) {
					menu->curcat->itemactive =
					    menu->curcat->itemsnb - 1;
				} else {
					menu->curcat->itemactive--;
				}
				if(item->inp > 0) item->inp *= -1;
				item =	&menu->curcat->items[menu->curcat->itemactive];
			} else if (event->key.keysym.sym == IK_DOWN) {
				menu->curcat->itemactive =
				    (menu->curcat->itemactive +
				     1) % (menu->curcat->itemsnb);
				/* Droite, + */
				if(item->inp > 0) item->inp *= -1;
				item = &menu->curcat->items[menu->curcat->itemactive];
			} else if (event->key.keysym.sym == IK_RIGHT) {
				switch (item->type) {
				case MENU_ITM_OPT:
					if (item->opt->value <
					    item->opt->max)
						item->opt->value++;
					else
						item->opt->value =
						    item->opt->min;

					break;
				case MENU_ITM_BCK:
					menu->curcat = item->lnk;
					break;
				case MENU_ITM_LNK:
					menu->curcat = item->lnk;
					break;
				case MENU_ITM_FCT:
					item->fct();
					break;
				}
				/* Gauche, - */
			} else if (event->key.keysym.sym == IK_LEFT) {
				switch (item->type) {
				case MENU_ITM_OPT:
					if (item->opt->value >
					    item->opt->min)
						item->opt->value--;
					else
						item->opt->value =
						    item->opt->max;

					break;
				}
			} else if (event->key.keysym.sym == IK_OK) {
				/* RETOUR lance l'action associe  un bouton */
				switch (item->type) {
				case MENU_ITM_OPT:
					if (item->opt->value <
					    item->opt->max)
						item->opt->value++;
					else
						item->opt->value =
						    item->opt->min;

					break;
				case MENU_ITM_BCK:
					menu->curcat = item->lnk;
					break;
				case MENU_ITM_LNK:
					menu->curcat = item->lnk;
					break;
				case MENU_ITM_FCT:
					item->fct();
					break;
				case MENU_ITM_INP:
					/*if(item->inp < 0) */item->inp *= -1;
					for (uint j = 0; j < menu->curcat->itemsnb; j++) {
                                                if(menu->curcat->items[j].inp > 0 && j != menu->curcat->itemactive)
                                                        menu->curcat->items[j].inp *= -1;
                                        }

					break;
				}
			} else if (item->inp > 0) {
				uint size = strlen(item->text);
				if (event->key.keysym.sym == SDLK_BACKSPACE) {
					item->text[size-1] = '\0';
				} else if(size+2 <= item->inp) {
					char c;
					c = event->key.keysym.unicode;
					if(c) {
						item->text[size] = c;
						item->text[size+1] = '\0';
					}
				}

			}

		}
		break;
	case SDL_QUIT:
		*isdone = 1;
		break;
	case SDL_MOUSEBUTTONDOWN:	/* si on click */
		if (event->button.button == SDL_BUTTON_LEFT || event->button.button == SDL_BUTTON_RIGHT) {
			for (uint i = 0; i < menu->curcat->itemsnb; i++) {
				if (menu->curcat->items[i].pos.x <=
				    event->button.x
				    && menu->curcat->items[i].pos.x +
				    menu->curcat->items[i].pos.w >=
				    event->button.x
				    && menu->curcat->items[i].pos.y <=
				    event->button.y
				    && menu->curcat->items[i].pos.y +
				    menu->curcat->items[i].pos.h >=
				    event->button.y) {
					for (uint j = 0; j < menu->curcat->itemsnb; j++) {
						if(menu->curcat->items[j].inp > 0) 
							menu->curcat->items[j].inp *= -1;
					}
					item = &menu->curcat->items[i];
					if(event->button.button == SDL_BUTTON_LEFT) {
						switch (item->type) {
						case MENU_ITM_OPT:
							if (item->opt->value <
							    item->opt->max)
								item->opt->value++;
							else
								item->opt->value =
									item->opt->min;
							
							break;
						case MENU_ITM_BCK:
							menu->curcat = item->lnk;
							break;
						case MENU_ITM_LNK:
							menu->curcat = item->lnk;
							break;
						case MENU_ITM_FCT:
							item->fct();
							break;
						case MENU_ITM_INP:
							item->inp *= -1;
							break;
						}
					} else if(event->button.button == SDL_BUTTON_RIGHT) {
						switch (item->type) {
						case MENU_ITM_OPT:
							if (item->opt->value >
							    item->opt->min)
								item->opt->value--;
							else
                                                item->opt->value =
							item->opt->max;

							break;
						}
					}
					i = menu->curcat->itemsnb;	/* On arrte */
				}
			}

		}
		break;

	case SDL_MOUSEBUTTONUP:	/* si on relache le bouton */
		if (event->button.button == SDL_BUTTON_LEFT) {

		}
		break;

	case SDL_MOUSEMOTION:
		for (uint i = 0; i < menu->curcat->itemsnb; i++) {
			if (menu->curcat->items[i].pos.x <= event->motion.x
			    && menu->curcat->items[i].pos.x +
			    menu->curcat->items[i].pos.w >= event->motion.x
			    && menu->curcat->items[i].pos.y <=
			    event->motion.y
			    && menu->curcat->items[i].pos.y +
			    menu->curcat->items[i].pos.h >=
			    event->motion.y) {
				item = &menu->curcat->items[i];
				menu->curcat->itemactive = i;
			}
		}
		break;
	}

	/* Actions a faire ensuite ... */
	switch (item->type) {
	case MENU_ITM_OPT:
		/* Verifie la cohrence des options, applique les changements, etc ... */
		if (options.ianb.value > options.playernb.value) {
			options.ianb.value = options.playernb.value;
		}
		if ((options.vmode.value != options.goodvmode)
		    || (options.vresol.value != options.goodvresol)) {

			uint flags = SDL_DOUBLEBUF;
			if (options.vmode.value == 1) {
				flags |= SDL_FULLSCREEN;
			}

			if (!SetVideoMode(vresols[options.vresol.value].w,
					  vresols[options.vresol.value].h,
					  32, flags)) {
				options.vmode.value = options.goodvmode;
				options.vresol.value = options.goodvresol;
			} else {
				char tmp[256];

				SDL_FreeSurface(menu->bg);	/* Fond */
				menu->bg = NULL;

				sprintf(tmp, DATA_PATH MENU_IMG_BACKGROUND,
					SCREEN_WIDTH, SCREEN_HEIGHT);
				menu->bg = LoadSDLImage(tmp, false);

				options.goodvmode = options.vmode.value;
				options.goodvresol = options.vresol.value;
			}

		}

		break;
	}
}

void DrawCat(struct s_menu_cat *cat, TTF_Font * font, SDL_Color catcolor,
	     SDL_Color actcolor, SDL_Color inactcolor, SDL_Rect * pos)
{
	SDL_Rect dst;
	SDL_Color color;

	dst.x = pos->x;
	dst.y = pos->y;

	PrintText(SDL_GetVideoSurface(), cat->name, &dst, font, catcolor);

	pos->w = dst.w;
	pos->h = 0;
	pos->h += dst.h * 3;

	for (uint i = 0; i < cat->itemsnb; ++i) {
		dst.x = pos->x;
		dst.y = pos->y + pos->h;

		if (i == cat->itemactive)
			color = actcolor;
		else
			color = inactcolor;

		DrawItem(&cat->items[i], font, color, &dst);

		if (pos->x > dst.w)
			pos->w = dst.w;

		pos->h += dst.h + 2;

	}
}

void DrawItem(struct s_menu_item *item, TTF_Font * font, SDL_Color color,
	      SDL_Rect * pos)
{
	char *tmp;

	if (item->type == MENU_ITM_OPT) {

		if (item->opt->text[1] == NULL) {
			char *tmp2;
			tmp2 = malloc(256);
			snprintf(tmp2, 256, "%d", item->opt->value);
			tmp =
			    malloc(strlen(item->text) + strlen(tmp2) + 3);

			sprintf(tmp, "%s: %s", item->text, tmp2);
			free(tmp2);
		} else {
			tmp =
			    malloc(strlen(item->text) +
				   strlen(item->opt->
					  text[item->opt->value]) + 3);

			sprintf(tmp, "%s: %s", item->text,
				item->opt->text[item->opt->value]);
		}
	} else if (item->type == MENU_ITM_INP) {
		if(item->inp > 0) {
			tmp = malloc(strlen(item->text) + 2);
			snprintf(tmp, strlen(item->text)+2, "%s_", item->text);
		} else {
			tmp = malloc(strlen(item->text) + 1);
			strcpy(tmp, item->text);
		}
	} else {
		tmp = malloc(strlen(item->text) + 1);
		strcpy(tmp, item->text);
	}

	PrintText(SDL_GetVideoSurface(), tmp, pos, font, color);

	item->pos = *pos;

	free(tmp);
}

void InitCat(struct s_menu_cat **cat, char *name, uint itemsnb, uint flags,
	     struct s_menu_cat *parent)
{
	*cat = malloc(sizeof(struct s_menu_cat));

	(*cat)->name = malloc(strlen(name) + 1);
	strcpy((*cat)->name, name);

	(*cat)->itemsnb = 0;
	(*cat)->itemsmax = itemsnb;
	(*cat)->itemactive = 0;
	(*cat)->items = malloc(sizeof(struct s_menu_item) * itemsnb);
	(*cat)->flags = flags;

	(*cat)->parent = parent;
}

void AddItemTxt(struct s_menu_cat *cat, char *text)
{
	if (cat->itemsnb >= cat->itemsmax) {
		fprintf(stderr, "Too much items in cat: %s\n", cat->name);
		return;
	}

	cat->items[cat->itemsnb].text = malloc(strlen(text) + 1);
	strcpy(cat->items[cat->itemsnb].text, text);

	cat->items[cat->itemsnb].type = MENU_ITM_TXT;

	cat->items[cat->itemsnb].lnk = NULL;
	cat->items[cat->itemsnb].opt = NULL;
	cat->items[cat->itemsnb].fct = NULL;
	cat->items[cat->itemsnb].inp = 0;

	cat->itemsnb++;
}

void AddItemOpt(struct s_menu_cat *cat, char *text, struct s_opt *opt)
{

	if (cat->itemsnb >= cat->itemsmax) {
		fprintf(stderr, "Too much items in cat: %s\n", cat->name);
		return;
	}

	if (text) {
		cat->items[cat->itemsnb].text = malloc(strlen(text) + 1);
		strcpy(cat->items[cat->itemsnb].text, text);
	} else {
		cat->items[cat->itemsnb].text =
		    malloc(strlen(opt->name) + 1);
		strcpy(cat->items[cat->itemsnb].text, opt->name);
	}


	cat->items[cat->itemsnb].type = MENU_ITM_OPT;

	cat->items[cat->itemsnb].opt = opt;
	cat->items[cat->itemsnb].lnk = NULL;
	cat->items[cat->itemsnb].fct = NULL;
	cat->items[cat->itemsnb].inp = 0;

	cat->itemsnb++;
}

void AddItemFct(struct s_menu_cat *cat, char *text, void (*fct)())
{

	if (cat->itemsnb >= cat->itemsmax) {
		fprintf(stderr, "Too much items in cat: %s\n", cat->name);
		return;
	}

	cat->items[cat->itemsnb].text = malloc(strlen(text) + 1);
	strcpy(cat->items[cat->itemsnb].text, text);

	cat->items[cat->itemsnb].fct = fct;
	cat->items[cat->itemsnb].lnk = NULL;
	cat->items[cat->itemsnb].opt = NULL;
	cat->items[cat->itemsnb].inp = 0;

	cat->items[cat->itemsnb].type = MENU_ITM_FCT;

	cat->itemsnb++;
}

void AddItemLnk(struct s_menu_cat *cat, char *text, struct s_menu_cat *lnk)
{

	if (cat->itemsnb >= cat->itemsmax) {
		fprintf(stderr, "Too much items in cat: %s\n", cat->name);
		return;
	}

	cat->items[cat->itemsnb].text = malloc(strlen(text) + 1);
	strcpy(cat->items[cat->itemsnb].text, text);

	cat->items[cat->itemsnb].lnk = lnk;
	cat->items[cat->itemsnb].opt = NULL;
	cat->items[cat->itemsnb].fct = NULL;
	cat->items[cat->itemsnb].inp = 0;

	cat->items[cat->itemsnb].type = MENU_ITM_LNK;

	cat->itemsnb++;
}

void AddItemBck(struct s_menu_cat *cat, char *text)
{

	if (cat->itemsnb >= cat->itemsmax) {
		fprintf(stderr, "Too much items in cat: %s\n", cat->name);
		return;
	}

	cat->items[cat->itemsnb].text = malloc(strlen(text) + 1);
	strcpy(cat->items[cat->itemsnb].text, text);

	cat->items[cat->itemsnb].lnk = cat->parent;
	cat->items[cat->itemsnb].opt = NULL;
	cat->items[cat->itemsnb].fct = NULL;
	cat->items[cat->itemsnb].inp = 0;

	cat->items[cat->itemsnb].type = MENU_ITM_BCK;

	cat->itemsnb++;
}

void AddItemInp(struct s_menu_cat *cat, char *text, uint size)
{

        if (cat->itemsnb >= cat->itemsmax) {
                fprintf(stderr, "Too much items in cat: %s\n", cat->name);
                return;
        }

/*        cat->items[cat->itemsnb].text = malloc(strlen(*text) + 1);
        strcpy(cat->items[cat->itemsnb].text, *text);
*/
	cat->items[cat->itemsnb].text = text;
	
        cat->items[cat->itemsnb].lnk = NULL;
        cat->items[cat->itemsnb].opt = NULL;
        cat->items[cat->itemsnb].fct = NULL;
	cat->items[cat->itemsnb].inp = -1*size;
	
        cat->items[cat->itemsnb].type = MENU_ITM_INP;
        cat->itemsnb++;
}

void QuitMenu()
{
	SDL_Event QuitEvn;
	QuitEvn.type = SDL_QUIT;

	SDL_PushEvent(&QuitEvn);
}

int LoadOptions() {
	FILE *file;
	char * filename = GetConfFile();
	char buffer[1024],text[1024];
	char * ptr;
	char * ptr2;
	struct s_options temp;
	uint i;

	printf("reading game options in %s\n", filename);

	if ( (file = fopen(filename, "r")) != NULL) {

		while(fgets(buffer, sizeof(buffer), file)) {
			ptr = strchr(buffer, '#');
			if(ptr != NULL) {
				ptr[0] = '\0';
			}
			
			if(sscanf(buffer, "PlayerNb \"%d\"",&temp.playernb.value) == 1) {
				if(options.playernb.min <= temp.playernb.value && options.playernb.max >= temp.playernb.value) {
					options.playernb.value = temp.playernb.value;
				}
			}

			if(sscanf(buffer, "IANb \"%d\"",&temp.ianb.value) == 1) {
				if(options.ianb.min <= temp.ianb.value && options.ianb.max >= temp.ianb.value) {
                                        options.ianb.value = temp.ianb.value;
                                }
			}

			if(sscanf(buffer, "Game Mode \"%d\"",&temp.mode.value) == 1) {
                                if(options.mode.min <= temp.mode.value && options.mode.max >= temp.mode.value) {
                                        options.mode.value = temp.mode.value;
                                }
			}

			if(sscanf(buffer, "Wall Size \"%d\"",&temp.wallsize.value) == 1) {
                                if(options.wallsize.min <= temp.wallsize.value && options.wallsize.max >= temp.wallsize.value) {
                                        options.wallsize.value = temp.wallsize.value;
                                }
			}

			if(sscanf(buffer, "Speed \"%d\"",&temp.speed.value) == 1) {
                                if(options.speed.min <= temp.speed.value && options.speed.max >= temp.speed.value) {
                                        options.speed.value = temp.speed.value;
                                }
			}

			if(sscanf(buffer, "Resolution \"%d\"",&temp.vresol.value) == 1) {
                                if(options.vresol.min <= temp.vresol.value && options.vresol.max >= temp.vresol.value) {
                                        options.vresol.value = temp.vresol.value;
                                }
			}

			if(sscanf(buffer, "Video mode \"%d\"",&temp.vmode.value) == 1) {
                                if(options.vmode.min <= temp.vmode.value && options.vmode.max >= temp.vmode.value) {
                                        options.vmode.value = temp.vmode.value;
                                }
			}

			for(i = 0; i < OPTMAX_PLAYERNB; i++) {
				snprintf(text,sizeof(text), "Key_%d_UP \\\"%%d\\\"", i);
				if(sscanf(buffer, text, &temp.keys[i][0]) == 1) {
					options.keys[i][0] = temp.keys[i][0];
				}
			       
                                snprintf(text,sizeof(text), "Key_%d_DOWN \\\"%%d\\\"", i);
                                if(sscanf(buffer, text, &temp.keys[i][1]) == 1) {
					options.keys[i][1] = temp.keys[i][1];
				}

                                snprintf(text,sizeof(text), "Key_%d_LEFT \\\"%%d\\\"", i);
                                if(sscanf(buffer, text, &temp.keys[i][2]) == 1) {
					options.keys[i][2] = temp.keys[i][2];
				}

                                snprintf(text,sizeof(text), "Key_%d_RIGHT \\\"%%d\\\"", i);
                                if(sscanf(buffer, text, &temp.keys[i][3]) == 1) {
					options.keys[i][3] = temp.keys[i][3];
				}
			}
			for(i = 0; i < OPTMAX_PLAYERNB; i++) {
				snprintf(text,sizeof(text), "Player_%d", i);
				if((ptr = strstr(buffer,text)) != NULL) {
					ptr=strchr(ptr,'"');
					ptr2=strrchr(ptr,'"');

					if(ptr != NULL && ptr != ptr2) {
						ptr2[0] = '\0';
						ptr++;
						snprintf(options.pnames[i],sizeof(options.pnames[i]), "%s", ptr);
					}
					
				}
				
			}

		}


		return 0;
	}
	else{
		printf("Cannot open file for reading: %s - loading defaults\n", filename);
		return -1;
	}
}

int SaveOptions() {
	FILE *file;
	char * filename = GetConfFile();
	uint i;

	printf("Saving game options in %s\n", filename);
	if ( (file = fopen(filename, "w")) != NULL) {
		fprintf(file,"#Ikswall Conf File\n"
			"#See /usr/include/SDL/SDL_keysym.h for Keys\n");
		fprintf(file,"PlayerNb \"%d\"\n",options.playernb.value);
		fprintf(file,"IANb \"%d\"\n",options.ianb.value);
		fprintf(file,"Game Mode \"%d\"\n",options.mode.value);
		fprintf(file,"Wall Size \"%d\"\n",options.wallsize.value);
		fprintf(file,"Speed \"%d\"\n",options.speed.value);
		fprintf(file,"Resolution \"%d\"\n",options.vresol.value);
		fprintf(file,"Video mode \"%d\"\n",options.vmode.value);

		for(i = 0; i < OPTMAX_PLAYERNB; i++) {
			fprintf(file,"Key_%d_UP \"%d\"\n"
				"Key_%d_DOWN \"%d\"\n"
				"Key_%d_LEFT \"%d\"\n"
				"Key_%d_RIGHT \"%d\"\n",
				i,options.keys[i][0],
				i,options.keys[i][1],
				i,options.keys[i][2],
				i,options.keys[i][3]);
		}
		for(i = 0; i < OPTMAX_PLAYERNB; i++) {
			fprintf(file,"Player_%d \"%s\"\n",i,options.pnames[i]);
		}
		fclose(file);
		return 0;
	}
	else{
		printf("Cannot open file for saving: %s\n", filename);
		return -1;
	}
}

char * GetConfFile() {
	char * filename;

#ifdef _GP2X
	filename = strdup("ikswall.conf");
	return filename;
#else
#ifndef WIN32
        struct passwd *pwp;


        /* get user home dir */
        if ( !(pwp = getpwuid(getuid()))){
                // error
                perror("attempt to get current user failed\n");
		return NULL;
        } else {
		filename=malloc(strlen(pwp->pw_dir) + strlen("/.ikswall") + 1);
		sprintf(filename, "%s/.ikswall", pwp->pw_dir);
		return filename;
	}
#endif
#endif
#ifdef WIN32
	filename = strdup("ikswall.conf");
	return filename;
#endif

}
