/*
** Copyright (C) 2005 CHARY Corentin <iksaif@gmail.com>
**
** Ce programme est libre, vous pouvez le redistribuer et/ou le modifier
** selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation
**
** Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
** y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
** Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
**
** Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme
**
** messages.h
**
** Permet d'afficher des messages un peu partout sur le jeu
** Avec des effets (fondu, clignotement, etc ...)
**
**
*/

#ifndef MESSAGES_H
# define MESSAGES_H

/* Include */
# include "SDL.h"

/* Headers locaux */
# include "main.h"

# define MESSAGE_FADING 1
# define MESSAGE_BLITTING 2

struct s_message {
	/* Texte */
	char text[256];

	/* Affichage */
	SDL_Color color;
	TTF_Font *font;

	/* Position */
	unsigned int x;
	unsigned int y;

	/* Dplacement */
	int dy;
	int dx;

	/* Flags */
	unsigned int flags;

	/* Temps au quel a sera finit */
	int time;

	/* Liste */
	struct s_message *prev;
	struct s_message *next;
};

struct s_messages {
	struct s_message *first;
	struct s_message *last;
};

void InitMessages(struct s_messages *messages);
void FreeMessages(struct s_messages *messages);

void HandleMessages(struct s_messages *messages);

void AddMessage(struct s_messages *messages, char *text, SDL_Color color,
		TTF_Font * font, unsigned int x, unsigned int y,
		int dx, int dy, unsigned int flags, unsigned int time);
void DelMessage(struct s_messages *messages, struct s_message *message);

#endif
